#include "fs9gauges.h"
#include "dsd_fs9_fuel_dump.h"

// LVAR.H defines a class I created to handle XML L:Variables.
#include "LVAR.H"

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "FSUIPC_User.h"
#include "ModuleUser.cpp"

#ifdef _DEBUG
FILE* fLog=NULL;
DWORD dwCount = 0;
#endif
/*
#define TANK_MAIN_RIGHT     0
#define TANK_MAIN_LEFT      1
#define TANK_AUX_RIGHT      2
#define TANK_AUX_LEFT       3
#define TANK_TIP_RIGHT      4
#define TANK_TIP_LEFT       5
#define TANK_CENTER         6
#define TANK_CENTER2        7
#define TANK_CENTER3        8
#define TANK_EXTERNAL1      9
#define TANK_EXTERNAL2      10
*/

struct _TankVar
{
	ENUM	en;
	PCSTRINGZ	name;
	double	val;
};
//_TankVar TankVar[11];
//_TankVar TankCapVar[11];
_TankVar	Gallons;


// I defined this structure to hold all the relevant information for each fuel tank.
// The class LVAR is defined in LVAR.H and is used to handle XML L:Variables.
typedef struct _TANK
{
	LVAR	lv;
	double	capacity;
	double	level;
	double	min_level;
	double	rate;
	double	then;
	double	now;
	int		active;
} _TANK;
_TANK Tank[11];

double fActiveTank;
double FuelChange = 0.;
double TimeSlice = 0;

int ipc_open = 0;
int ProcessPlease = 0;
BYTE Mem[4000];
DWORD lev_addr[] = {0x0b94, 0x0b7c, 0x0b9c, 0x0b84, 0x0ba4, 0x0b8c, 0x0b74, 0x1244, 0x124c, 0x1254, 0x125c};
DWORD dwTankLevel[11];
DWORD FSReq = SIM_ANY;
DWORD Result;
DWORD Size=4000;
DWORD dwFuelWrite;

int j = 0;
int ii;
int i = 0;
int iFlip = 0;

MODULE_VAR mvSeconds = {ELAPSED_SECONDS};
MODULE_VAR mvWeight = { FUEL_WEGHT_PER_GALLON };

void FSAPI GetCapacity()
{
	double fuelx = 0.;
	execute_calculator_code("(A:FUEL TANK CENTER CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_CENTER].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK CENTER2 CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_CENTER2].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK CENTER3 CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_CENTER3].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK LEFT MAIN CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_MAIN_LEFT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK LEFT AUX CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_AUX_LEFT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK LEFT TIP CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_TIP_LEFT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK RIGHT MAIN CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_MAIN_RIGHT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK RIGHT AUX CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_AUX_RIGHT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK RIGHT TIP CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_TIP_RIGHT].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK EXTERNAL1 CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_EXTERNAL1].capacity = fuelx;
	execute_calculator_code("(A:FUEL TANK EXTERNAL2 CAPACITY, gallons)", &fuelx, NULL, NULL);
	Tank[TANK_EXTERNAL2].capacity = fuelx;
}
void FSAPI TankRoutine(int t)
{
	double RateGPS;
	Tank[t].level = (double)(dwTankLevel[t]) / 8388608. * Tank[t].capacity;
		// Update the dump rate.
	Tank[t].rate = Tank[t].lv.GetLVar();
		//Time that has elapsed since we were last here.
	Tank[t].then = Tank[t].now;
	Tank[t].now = mvSeconds.var_value.n;
	TimeSlice = Tank[t].now - Tank[t].then;  
	if ( TimeSlice < 0. ) TimeSlice = 0.;
	if ( TimeSlice > 2. ) TimeSlice = 0.;
		// The amount of fuel we are going to drop.
	RateGPS = (Tank[t].rate / 3.600) / mvWeight.var_value.n;
	FuelChange = (TimeSlice * RateGPS) / 1000.;
		//  We can't drop more than we have, and we can't add more than the available capacity.
	if ( FuelChange > Tank[t].level ) FuelChange = Tank[t].level;
	if ( FuelChange < Tank[t].level - Tank[t].capacity ) FuelChange = Tank[t].level - Tank[t].capacity;
		// Making FuelChange equal to the new value we are going to write
	FuelChange = Tank[t].level - FuelChange;
		// Write the new fuel level.
	if ( FuelChange != Tank[t].level )
		{
		dwFuelWrite = (DWORD)((FuelChange * 8388608. / Tank[t].capacity)+0.5);
		FSUIPC_Write( lev_addr[t], sizeof(DWORD), &dwFuelWrite, &Result );
		ProcessPlease = 1;
#ifdef _DEBUG
		dwCount++;
		fprintf_s( fLog,"\nCount=%d Tank=%d Old=%6.8f Rate=%5.2f Change=%3.8f New=%6.8f dwFR=%d Time=%1.8f PPH=%f GPS=%f", dwCount,t,Tank[t].level, Tank[t].rate,Tank[t].level-FuelChange,FuelChange,dwFuelWrite,TimeSlice, Tank[t].rate, RateGPS);
#endif
		}
}

void FSAPI	module_init(void)
	{
	ZeroMemory ( &Tank[0], sizeof(_TANK)*11 );
	
#ifdef _DEBUG
	if ( !fLog ) fLog = fopen("./FuelDump.log","a");
#endif

	Tank[TANK_MAIN_RIGHT].lv.Register("RATE_TANK_MAIN_RIGHT");
	Tank[TANK_MAIN_LEFT].lv.Register("RATE_TANK_MAIN_LEFT");
	Tank[TANK_AUX_RIGHT].lv.Register("RATE_TANK_AUX_RIGHT");
	Tank[TANK_AUX_LEFT].lv.Register("RATE_TANK_AUX_LEFT");
	Tank[TANK_TIP_RIGHT].lv.Register("RATE_TANK_TIP_RIGHT");
	Tank[TANK_TIP_LEFT].lv.Register("RATE_TANK_TIP_LEFT");
	Tank[TANK_CENTER].lv.Register("RATE_TANK_CENTER");
	Tank[TANK_CENTER2].lv.Register("RATE_TANK_CENTER2");
	Tank[TANK_CENTER3].lv.Register("RATE_TANK_CENTER3");
	Tank[TANK_EXTERNAL1].lv.Register("RATE_TANK_EXTERNAL1");
	Tank[TANK_EXTERNAL2].lv.Register("RATE_TANK_EXTERNAL2");

	Gallons.name = "Gallons";
	Gallons.en = get_units_enum(Gallons.name);
	}		

void FSAPI	module_deinit(void)
	{
#ifdef _DEBUG
	_fcloseall();
	fLog = NULL;
#endif
	}

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)	
{
	return TRUE;
}

#define	GAUGE_NAME  "fuel_dump\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_fuel_dump
#define	GAUGE_W    10
#include	"dsd_fs9_fuel_dump0.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

#define	GAUGE_NAME  "display\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_fuel_dump_display
#define	GAUGE_W    300
#include	"dsd_fs9_fuel_dump_display.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

GAUGESIMPORT	ImportTable =							
{														
	{ 0x0000000F, (PPANELS)NULL },
	{ 0x00000000, NULL }								
};

GAUGESLINKAGE	Linkage =								
{														
	0x00000013,											
	module_init,										
	module_deinit,										
	0,													
	0,
	FS9LINK_VERSION, 
	{
		(&gaugehdr_fuel_dump),
		(&gaugehdr_fuel_dump_display),
		0 
	}
};
