
#pragma once
#ifndef LVAR_H
#define LVAR_H
#include "fs9gauges.h"

void FSAPI LVGetStringA(wchar_t* FileNameIn, char* FileNameOut)
	{
	size_t strlenW = wcslen(FileNameIn);
	int strlenA = WideCharToMultiByte(CP_ACP, 0, FileNameIn, -1, 0, 0, NULL, NULL);
	if ( strlenA > 0 )
		{
		WideCharToMultiByte(CP_ACP, 0, FileNameIn, -1, FileNameOut, strlenA, NULL, NULL);
		}
	}
void FSAPI LVGetStringW(char* SourceStringA, wchar_t* TargetStringW )
{
	int strlenW;
	int strlenA = strlen(SourceStringA);
	strlenW = MultiByteToWideChar(CP_ACP, 0, SourceStringA, -1, TargetStringW, 0);
	if ( strlenW > 0 )
		{
		MultiByteToWideChar(CP_ACP, 0, SourceStringA, -1, TargetStringW, strlenW);
		}
}

class LVAR
{
private:
	int		id_number;
	char	name[MAX_PATH];
	static wchar_t* scratch;

public:
LVAR::LVAR()
	{
	id_number = -1;
	name[0] = NULL;
	}
LVAR::~LVAR()
	{;
	name[0] = NULL;
	id_number = -1;
	}
wchar_t* FSAPI GetNameW()
	{
	if ( scratch ) { delete[] scratch; scratch = NULL; }
	scratch = new wchar_t[strlen(name)+1];
	scratch[0] = NULL;
	LVGetStringW( name, scratch );
	if (scratch) return scratch;
	else return NULL;
	}
char* FSAPI GetNameA()
	{
	if ( name )	return name;
	else return NULL;
	}
int FSAPI GetID()
	{
	return id_number;
	}
HRESULT FSAPI Register(wchar_t* NameIn)
	{
		name[0] = NULL;
		LVGetStringA( NameIn, name );
		id_number = register_named_variable( name );
		return S_OK;
	}
HRESULT FSAPI Register(char* NameIn)
	{
		name[0] = NULL;
		strcpy_s(name, strlen(NameIn)+1, NameIn);
		id_number = register_named_variable( name );
		return S_OK;
	}
HRESULT FSAPI RegisterA(char* NameIn)
	{
		name[0] = NULL;
		strcpy_s(name, strlen(NameIn)+1, NameIn);
		id_number = register_named_variable( name );
		return S_OK;
	}
HRESULT FSAPI Check()
	{
	id_number = check_named_variable( name );
	return id_number;
	}
HRESULT FSAPI Check(char* NameIn)
	{
	name[0] = NULL;
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if ( id_number <= 0 ) id_number = register_named_variable( name );
	id_number = check_named_variable( name );
	return id_number;
	}
HRESULT FSAPI Check(wchar_t* NameIn)
	{
	name[0] = NULL;
	LVGetStringA( NameIn, name );
	if ( id_number <= 0 ) register_named_variable( name );
	id_number = check_named_variable( name );
	return id_number;
	}
HRESULT FSAPI SetLVar(double AmountIn)
	{
	set_named_variable_value ( id_number, AmountIn );
	return S_OK;
	}

HRESULT FSAPI SetLVar(char* NameIn, double AmountIn)
	{
	name[0] = 0;
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if ( id_number < 0 ) register_named_variable( name );
	if ( id_number <= 0 ) id_number = check_named_variable( name );
	set_named_variable_value ( id_number, AmountIn );
	return S_OK;
	}

HRESULT FSAPI SetLVar(wchar_t* NameIn, double AmountIn)
	{
	name[0] = 0;
	LVGetStringA( NameIn, name );
	if ( id_number < 0 ) register_named_variable( name );
	if ( id_number <= 0 ) id_number = check_named_variable( name );
	set_named_variable_value ( id_number, AmountIn );
	return S_OK;
	}

double FSAPI GetLVar(char* NameIn)
	{
	name[0] = NULL;
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if ( id_number < 0 ) register_named_variable( name );
	if ( id_number <= 0 ) id_number = check_named_variable( name );
	return get_named_variable_value ( id_number );
	}
double FSAPI GetLVar(wchar_t* NameIn)
	{
	name[0] = NULL;
	LVGetStringW( name, NameIn );
	if ( id_number < 0 ) register_named_variable( name );
	if ( id_number <= 0 ) id_number = check_named_variable( name );
	return get_named_variable_value ( id_number );
	}
double FSAPI GetLVar()
	{
	if ( id_number <= 0 ) id_number = check_named_variable( name );
	return get_named_variable_value ( id_number );
	}
};

wchar_t* LVAR::scratch = NULL;

#endif